{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O+,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 1024,0,0}

unit CalcDlg;

interface

uses WinTypes, WinProcs, OWindows, ODialogs, Strings;

type
  TCalcDlg=object(TDialog)
    NTimer:integer;
    FixedMessage:string;
    constructor Init (AParent:PWindowsObject);
    procedure SetupWindow; virtual;
    function CanClose : boolean; virtual;
    procedure Cancel (var Msg:TMessage); virtual ID_FIRST+IDCANCEL;
    procedure WMTimer (var Msg:TMessage); virtual WM_FIRST+WM_TIMER;
    function Calc:integer; virtual;
    procedure DrawMessage (Msg:string);
    procedure DrawFixedMessage;
  end;
  PCalcDlg=^TCalcDlg;

implementation

constructor TCalcDlg.Init (AParent:PWindowsObject);
begin
  inherited Init(AParent,'CalcDlg');
  FixedMessage:=''; NTimer:=0;
end;

function TCalcDlg.CanClose:boolean;
begin
  if (NTimer<>0) then KillTimer(HWindow,NTimer);
  CanClose:=TRUE;
end;

procedure TCalcDlg.Cancel (var Msg:TMessage);
begin
  if (NTimer<>0) then begin
    KillTimer(HWindow,NTimer); NTimer:=0;
  end;
  EndDlg(IDCANCEL);
end;

procedure TCalcDlg.SetupWindow;
begin
  inherited SetupWindow;
  DrawFixedMessage;
  if (0=Calc) then begin
    NTimer:=100; SetTimer(HWindow,NTimer,5,nil);
  end
  else begin
    EnableWindow(GetDlgItem(HWindow,IDOK),TRUE);
    EnableWindow(GetDlgItem(HWindow,IDCANCEL),FALSE);
    NTimer:=0;
  end;
end;

procedure TCalcDlg.WMTimer (var Msg:TMessage);
begin
  if (0<>Calc) then begin
    EnableWindow(GetDlgItem(HWindow,IDOK),TRUE);
    EnableWindow(GetDlgItem(HWindow,IDCANCEL),FALSE);
    KillTimer(HWindow,NTimer); NTimer:=0;
  end;
end;

procedure TCalcDlg.DrawMessage (Msg:string);
var p:array[0..100] of char;
begin
  SetWindowText(GetDlgItem(HWindow,101),{@Msg}StrPCopy(p,Msg));
end;

procedure TCalcDlg.DrawFixedMessage;
var p:array[0..100] of char;
begin
  if (FixedMessage<>'') then
    SetWindowText(GetDlgItem(HWindow,102),{@FixedMessage}StrPCopy(p,FixedMessage));
end;

function TCalcDlg.Calc:integer;
begin
  Calc:=-1;
end;

end.