{$A+,B-,D+,F-,G+,I+,K+,L+,N-,P-,Q-,R-,S+,T-,V+,W+,X+,Y+}
{$M 16384,8192}
program ELW;

uses WinProcs, WinTypes, Objects, OWindows, ODialogs, OPrinter,
     CommDlg, ToolHelp,
     Strings,
     ExMDI, TpString,
     Elw_Codes, Elw_Path,
     Elw_Ind, Elw_Book, Elw_Quit, Elw_Search, Elw_Rubr, Elw_Lang,
     Elw_TCol,
     Elw_Info,
     Elw_About,
     Elw_Topic,
     (*---
     Elw_EdTr, ---*)
     {, Ani_Icon} HaspSec;

{$R ELW.RES}

const AddingLimit={$ifndef DEMO}500{$else}10{$endif};
      NewLoLimit=20000;

type
  TElwApp = object(TApplication)
    procedure InitMainWindow; virtual;
    function IdleAction:boolean; virtual;
  end;

  PMyMDI=^TMyMDI;
  TMyMDI=object(TExMDIWindow)
    PTL:PTermListW;
    TheFont:HFont;
    Printer  : PPrinter;
    MainX,MainY,MainW,MainH,MainState:integer;
    {IconWin:PIconWindow;}
    constructor Init (ATitle:Pchar; AMenu:THandle);
    destructor Done; virtual;
    procedure WMSize (var Msg: TMessage); virtual wm_First+wm_Size;
    procedure WMGetMinMaxInfo (var Msg: TMessage); virtual wm_First+wm_GetMinmaxInfo;
    procedure GetStatusText (ID:Word; Buffer:PChar; BufferMax:Integer); virtual;
    function GetProgramCopyright:string; virtual;
    function GetHelpCtx (WParam:Word) : integer; virtual;
    procedure CreateSpeedBar; virtual;
    procedure SetupWindow; virtual;
    function CanClose:boolean; virtual;
    procedure CloseChildren; virtual;
    function GetClassName:PChar; virtual;
    procedure GetWindowClass(var WndClass:TWndClass); virtual;
    procedure Idle;
    procedure About (var Msg: TMessage); virtual cm_First+cmAbout;
    procedure Info (var Msg: TMessage); virtual cm_First+cmInfo;
    procedure Ref (var Msg: TMessage); virtual cm_First+cmRef;
    procedure Search (var Msg: TMessage); virtual cm_First+cmSearch;
    procedure SearchAgain (var Msg: TMessage); virtual cm_First+cmSearchA;
    procedure Unselect (var Msg: TMessage); virtual cm_First+cmUnselect;
    procedure NewTerm (var Msg: TMessage); virtual cm_First+cmNewTerm;
    procedure DelTerm (var Msg: TMessage); virtual cm_First+cmDelTerm;
    procedure EdTerm (var Msg: TMessage); virtual cm_First+cmEdTerm;
    procedure Comment (var Msg: TMessage); virtual cm_First+cmComment;
    procedure ToPrint (var Msg: TMessage); virtual cm_First+cmPrint;
    procedure ToFile (var Msg: TMessage); virtual cm_First+cmFile;
    procedure ToClip (var Msg: TMessage); virtual cm_First+cmClip;
    procedure List (var Msg: TMessage); virtual cm_First+cmList;
    procedure Rubr (var Msg: TMessage); virtual cm_First+cmRubr;
    procedure FocusList (var Msg: TMessage); virtual cm_First+cmFocusList;
    function FindTopicOnTheScreen (id:integer) : PMyMDIChild;
    function CanCreateNewWindow : boolean;
    procedure ShowTopic (var Msg:TMessage); virtual cm_First+cmShowTopic;
    procedure ShowTopic1 (var Msg:TMessage); virtual wm_First+cmShowTopic;
    procedure EscPressed (var Msg:TMessage); virtual cm_First+cm_DoYouWishToBeClosed;
    procedure SetIndText;
    procedure SetRubText;
    procedure MakeDefaultFont (var AFont: HFont);
    procedure CMFonts (var Msg:TMessage); virtual cm_First + cmFont;
    procedure CMSetupPrinter (var Msg: TMessage); virtual cm_First + cmSetupPrinter;
    procedure MinimizeAll (var Msg:TMessage); virtual cm_First+cmMinAll;
    procedure SaveSt (var Msg:TMessage); virtual cm_First+cmSaveSt;
    procedure LoadSt (var Msg:TMessage); virtual cm_First+cmLoadSt;
    procedure LoadDefSt (var Msg:TMessage); virtual cm_First+cmLoadDefSt;
    procedure Loading;
    procedure ShowSavedTopics;
  end;

procedure TElwApp.InitMainWindow;
var pc:array[0..79] of char;
begin
  VerStr:=long2str(ver)+'.'+LeftPadCh(long2str(subver),'0',2);
  StrPCopy(pc,'-');
  MainWindow:=New(PMyMDI,Init(pc,LoadMenu(HInstance,'MainMenu')));
  HAccTable:=LoadAccelerators(HInstance,'AccTable');
  PMDIWindow(MainWindow)^.ChildMenuPos:=3;
end;

procedure LoadAndCheckBase(aHWindow : HWnd);forward;

function TElwApp.IdleAction:boolean;
begin
  PMyMDI(MainWindow)^.Idle;
  IdleAction:=true;
end;

constructor TMyMDI.Init (ATitle:Pchar; AMenu:THandle);
begin
  inherited Init(ATitle,AMenu);
  CheckPaths;
  LoadAndCheckBase(HWindow); {<<<}
  MainX:=-1;
  WC.Init;
  Loading;
  if MainX>=0 then
    with Attr do begin
      x:=MainX; y:=MainY; w:=MainW; h:=MainH;
      case MainState of
        0: CmdShow:=SW_ShowMinimized;
        2: CmdShow:=SW_ShowMaximized;
      end;
    end;
  TheFont:=0;
  Printer:=New(PPrinter, Init);
end;

destructor TMyMDI.Done;
begin
  if TheFont<>0 then DeleteObject(TheFont);
  Dispose(Printer,Done);
  WC.Done;
  inherited Done;
end;

procedure TMyMDI.WMSize (var Msg: TMessage);
var ClientW,ClientH:integer;
begin
  ClientW:=Msg.lParamLo; ClientH:=Msg.lParamHi;
  inherited WMSize (Msg);
end;

procedure TMyMDI.WMGetMinMaxInfo (var Msg: TMessage);
type PMinMaxInfo=^TMinMaxInfo;
     TMinMaxInfo=array[0..4] of TPoint;
begin
  with PMinMaxInfo(Msg.lParam)^[3] do begin
    x:=500; y:=300;
  end;
end;

procedure TMyMDI.Idle;
var ActChild:Hwnd;
  function found(P: PMyMDIChild): Boolean; far;
  begin
    found := ActChild = P^.HWindow;
  end;
var pch:PMyMDIChild;
    hm:hmenu;
    i:integer;
begin
  ActChild:=GetActiveChild;
  pch:=PMyMDIChild(FirstThat(@found));
  if pch=nil then Exit;
  hm:=GetSubMenu(Attr.Menu,1);
  if pch^.ChildId=-2 then {}
    for i:=0 to 9 do
      EnableMenuItem(hm,i,mf_byposition or mf_grayed)
  else
    if pch^.ChildId=-1 then { }
      for i:=0 to 9 do
        case i of
          0..2,4: EnableMenuItem(hm,i,mf_byposition or mf_grayed);
          6..8:
            if LocalIsNetworkDrv then
              EnableMenuItem(hm,i,mf_byposition or mf_grayed)
            else
              EnableMenuItem(hm,i,mf_byposition or mf_enabled);
        end
    else {}
      for i:=0 to 9 do
        case i of
          0..2: EnableMenuItem(hm,i,mf_byposition or mf_enabled);
          4:if LocalIsNetworkDrv then
              EnableMenuItem(hm,i,mf_byposition or mf_grayed)
            else
              EnableMenuItem(hm,i,mf_byposition or mf_enabled);
          6..8: EnableMenuItem(hm,i,mf_byposition or mf_grayed)
        end;
end;

procedure TMyMDI.GetStatusText (ID:Word; Buffer:PChar; BufferMax:Integer);
var str:string;
begin
  inherited GetStatusText(ID,Buffer,BufferMax);
  if Buffer[0]=#0 then begin
    case ID of
      cm_HelpContents: str:='   ';
      cm_HelpHelp:     str:='    Windows';
      cmAbout:   str:='  ';
      cmRef:     str:='   ';
      cmInfo:    str:='     ';
      cmFile:    str:='    ';
      cmPrint:   str:='  ';
      cmClip:    str:='   clipboard';
      1016{cmSetupPrinter}: str:=' ';
      cmComment: str:='   ';
      cmNewTerm: str:='  ';
      cmDelTerm: str:='  ';
      cmEdTerm:  str:='  ';
      cmList:    str:='  ';
      cmRubr:    str:='  ';
      cmSearch:  str:=' ';
      cmSearchA: str:='  ';
      cmUnselect:str:='    ';
      cmColor:   str:=' ';
      cmFont:    str:='   ';
      cmMinAll:  str:='    ';
      cmSaveSt:  str:='    (, , ...)';
      cmLoadSt:  str:='    ';
      cmLoadDefSt:str:='   ';
      998,1000..1004: str:=' ';
    else
      str:='    '+long2str(ID);
    end;
    StrPCopy(Buffer,copy(str,1,BufferMax-1));
  end;
end;

function TMyMDI.GetProgramCopyright:string;
begin
  GetProgramCopyright:='(c)  1995,96 - MS Windows  '+VerStr;
end;

function TMyMDI.GetHelpCtx (WParam:Word) : integer;
begin
  case WParam of
    cm_Exit:   GetHelpCtx:=hcExit;
    {1011:      gethelpCtx:=2;
    1001:      gethelpCtx:=3;
    1002:      gethelpCtx:=4;}
    cmRef:     GetHelpCtx:=hcRef;
    cmInfo:    GetHelpCtx:=hcInfo;
    cmAbout:   GetHelpCtx:=hcAbout;
    {cmSetupPrinter}1016: GetHelpCtx:=hcSetupPrinter;
    cmFile:    GetHelpCtx:=hcFile;
    cmPrint:   GetHelpCtx:=hcPrint;
    cmClip:    GetHelpCtx:=hcClip;
    cmComment: GetHelpCtx:=hcComment;
    cmNewTerm: GetHelpCtx:=hcNewTerm;
    cmDelTerm: GetHelpCtx:=hcDelTerm;
    cmEdTerm:  GetHelpCtx:=hcEdTerm;
    cmSearch,cmSearchA: GetHelpCtx:=hcSearch;
    cmRubr:    GetHelpCtx:=hcRubr;
    cmList:    GetHelpCtx:=hcList;
    cmColor:   GetHelpCtx:=hcColor;
    cmFont:    GetHelpCtx:=hcFont;
    cmSaveSt,cmLoadSt,cmLoadDefSt: GetHelpCtx:=hcSystemState;
    991..992,24335..24338,cmMinAll,3841..3850: GetHelpCtx:=hcWinOps;
  else
    GetHelpCtx:=0;
  end;
end;

procedure TMyMDI.SetupWindow;
begin
  inherited SetupWindow;
  MakeDefaultFont(TheFont);
  StatusWin[0]:=new(PStatusWindow,Init(@self,cmFocusList)); StatusWin[0]^.Width:=100;
  Application^.MakeWindow(StatusWin[0]);
  StatusWin[1]:=new(PStatusWindow,Init(@self,cmList)); StatusWin[1]^.Width:=70;
  Application^.MakeWindow(StatusWin[1]);
  StatusWin[2]:=new(PStatusWindow,Init(@self,cmRubr)); StatusWin[2]^.Width:=50;
  Application^.MakeWindow(StatusWin[2]);
  SetIndText; SetRubText;
  {IconWin:=new(PIconWindow,Init(@Self));
  Application^.MakeWindow(IconWin);}
  PTL:=New(PTermListW,Init(@Self,TheFont));
  Application^.MakeWindow(PTL);
  ShowSavedTopics;
end;

function TMyMDI.CanClose:boolean;
var fl:boolean;
    Msg:TMessage;
begin
  fl:=IDOK=Application^.ExecDialog(new(PQuitDlg,Init(@self)));
  if fl and SaveState then SaveSt(Msg);
  CanClose:=fl;
end;

const ElwClassName='ElwMainWindow';
function TMyMDI.GetClassName:PChar;
begin
  GetClassname:=ElwClassName;
end;

procedure TMyMDI.GetWindowClass(var WndClass:TWndClass);
begin
  inherited GetWindowClass(WndClass);
  WndClass.hIcon:=LoadIcon(HInstance,'AMainWinIco');
end;

procedure TMyMDI.CreateSpeedBar;
begin
  if SpeedBar<>nil then SpeedBar^.Free;
  SpeedBar:=New(PSpeedBar,Init(@Self,StatusLine));
  with SpeedBar^ do begin
    AddATool(cm_HelpContents,Pchar('BtnHelp'),'');
    AddSeparator;
    AddATool(cmRef,PChar('BtnBook'),'');
    AddATool(cmInfo,PChar('BtnStat'),'');
    AddSeparator;
    AddATool(cmFile,PChar('BtnSave'),'  ');
    AddATool(cmPrint,PChar('BtnPrint'),'  ');
    AddATool(cmClip,PChar('BtnClip'),'  clipboard');
    AddSeparator;
    AddATool(cmComment,PChar('BtnAttach'),'');
    AddSeparator;
    AddATool(cmSearch,PChar('BtnSearch'),'');
    AddATool(cmSearchA,PChar('BtnSearchAgain'),' ');
    AddATool(cmUnselect,PChar('BtnUnund'),' ');
    AddSeparator;
    AddATool(cmRubr,PChar('BtnRubrics'),'');
    AddATool(cmList,PChar('BtnFlags'),' / ');
    AddSeparator;
    AddATool(992,PChar('BtnPrev'),' ');
    AddATool(991,PChar('BtnNext'),' ');
    AddATool(cmMinAll,PChar('BtnMini'),'  ');
    AddATool(cm_CloseChildren,PChar('BtnClose'),'  ');
    AddSeparator;
    AddATool(cmFont,PChar('BtnFonts'),'');
    AddSeparator;
    AddATool(cmLoadDefSt,PChar('BtnHome'),' ');
    AddSeparator;
    AddATool(cm_Exit,Pchar('BtnQuit'),'');
  end;
end;

procedure TMyMDI.About (var Msg: TMessage);
begin
  Application^.ExecDialog(new(PAboutDlg,Init(@Self,VerStr)));
end;

procedure TMyMDI.Info (var Msg: TMessage);
var pc:array[0..255] of char;
begin
  MessageBox(HWindow,StrPCopy(pc,InfoAboutDb),
             '  ',MB_OK or MB_IconInformation);
end;

procedure TMyMDI.Ref (var Msg: TMessage);
begin
  if RefWin=0 then
    Application^.MakeWindow(new(PRefWindow,Init(@self,TheFont)))
  else begin
    SetWindowPos(RefWin,{HWND_TOP=0}0,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE);
    if IsIconic(RefWin) then OpenIcon(RefWin);
  end;
end;

procedure TMyMDI.NewTerm (var Msg: TMessage);
var maxid,private,i:integer;
    pc:array[0..255] of char;
begin
  (*---
  maxid:=0;
  for i:=0 to Index^.Count-1 do
    with Index^.At(i)^ do
      if id>maxid then maxid:=id;
  if maxid<NewLoLimit then maxid:=NewLoLimit;
  inc(maxid);
  Private:=0;
  for i:=0 to Index^.Count-1 do
    if Index^.At(i)^.IsPrivate then inc(Private);
  if Private>=AddingLimit then
    MessageBox(HWindow,
               StrPCopy(pc,'    '#13+long2str(AddingLimit)+'  '#13'  !!!'),
               ' ', MB_OK or MB_IconExclamation)
  else
    if IDOK=Application^.ExecDialog(new(PEdTrmDlg,Init(@Self,TheFont,-maxid))) then begin
      SetIndText;
      PTL^.FillList;
      Msg.LParam:=maxid;
      ShowTopic1(Msg);
      Rubr(Msg);
    end;
  ---*)
end;

procedure TMyMDI.DelTerm (var Msg: TMessage);
var n:integer;
    pc:array[0..255] of char;
    id:integer;
    i:integer;
    f,g:TBufStream;
    ident:integer;
    AMask:set of 0..11;
    b:byte;
    addr:longint;
    str:string;
    fi:file;
begin
  (*---
  n:=PTL^.CB^.GetSelIndex;
  if (n<0) then Exit;
  n:=PTL^.IndexN^[n];
  if not Index^.At(n)^.IsPrivate then
    MessageBox(HWindow,' '#13'   !',' ',MB_OK or MB_IconStop)
  else
    if IdYes=
         MessageBox(HWindow,
            StrPCopy(pc,'  '#13+
                        ' '#13+
                        Index^.At(n)^.Name+' ?'#13#13+
                        ',   '#13'   '),
            '  ?',MB_YesNo or MB_IconQuestion)
    then begin
      id:=Index^.At(n)^.id;
      {    }
      CloseChildren;
      {  el-l.ind}
      g.Init(LP('el-l.new'),stCreate,1024);
      f.Init(LP('el-l.ind'),stOpenRead,1024);
      while f.Status=stOK do begin
        f.Read(ident,2); f.Read(addr,4); f.Read(AMask,2); f.Read(b,1);
        if f.status=stOK then begin
          GetString(f,str,false);
          if (ident>0) and (id<>ident) then begin
            g.Write(ident,2); g.Write(addr,4); g.Write(AMask,2); g.Write(b,1);
            PutString(g,str);
          end;
        end;
      end;
      f.Done; g.Done;
      assign(fi,LP('el-l.ind')); erase(fi);
      assign(fi,LP('el-l.new')); rename(fi,LP('el-l.ind'));
      {,    }
      DoneIndex;
      InitIndex;
      SetIndText;
      PTL^.FillList;
    end;
  ---*)
end;

procedure TMyMDI.EdTerm (var Msg: TMessage);
var n:integer;
    TopicWin:PMyMDIChild;
begin
  (*---
  n:=PTL^.CB^.GetSelIndex;
  if (n<0) then Exit;
  n:=PTL^.IndexN^[n];
  if Index^.At(n)^.IsPrivate then begin
    TopicWin:=FindTopicOnTheScreen(Index^.At(n)^.id);
    if TopicWin<>nil then {   !}
      TopicWin^.CloseWindow;
    if IDOK=Application^.ExecDialog(new(PEdTrmDlg,Init(@Self,TheFont,n))) then begin
      Msg.LParam:=Index^.At(n)^.id;
      ShowTopic1(Msg);
    end;
  end
  else
    MessageBox(HWindow,'    ',' ',MB_OK or MB_IconExclamation);
  ---*)
end;

procedure TMyMDI.Search (var Msg: TMessage);
  procedure ReDraw (AChild: PWindowsObject); far;
  begin
    if PMyMdiChild(AChild)^.ChildId>=0 then begin
      InvalidateRect(AChild^.HWindow,nil,true);
      UpdateWindow(AChild^.HWindow);
    end;
  end;
begin
  FocusList(Msg);
  SendMessage(GetActiveChild,wm_SysCommand,cmSearch,0);
  ForEach(@ReDraw);
end;

procedure TMyMDI.SearchAgain (var Msg: TMessage);
  procedure ReDraw (AChild: PWindowsObject); far;
  begin
    if PMyMdiChild(AChild)^.ChildId>=0 then begin
      InvalidateRect(AChild^.HWindow,nil,true);
      UpdateWindow(AChild^.HWindow);
    end;
  end;
begin
  if SearchStr='' then
    MessageBox(HWindow,'    ','...',MB_OK or MB_IconExclamation)
  else begin
    FocusList(Msg);
    SendMessage(GetActiveChild,wm_SysCommand,cmSearchA,0);
    ForEach(@ReDraw);
  end;
end;

procedure TMyMDI.Unselect (var Msg: TMessage);
  procedure ReDraw (AChild: PWindowsObject); far;
  begin
    if PMyMdiChild(AChild)^.ChildId>=0 then begin
      InvalidateRect(AChild^.HWindow,nil,true);
      UpdateWindow(AChild^.HWindow);
    end;
  end;
begin
  if SearchStr<>'' then begin
    SearchStr:='';
    ForEach(@ReDraw);
  end;
end;

procedure TMyMDI.Comment (var Msg: TMessage);
begin
  SendMessage(GetActiveChild,wm_SysCommand,cmComment,0);
end;

procedure TMyMDI.ToPrint (var Msg: TMessage);
begin
  SendMessage(GetActiveChild,wm_SysCommand,cmPrint,0);
end;

procedure TMyMDI.ToClip (var Msg: TMessage);
begin
  SendMessage(GetActiveChild,wm_SysCommand,cmClip,0);
end;

procedure TMyMDI.ToFile (var Msg: TMessage);
begin
  SendMessage(GetActiveChild,wm_SysCommand,cmFile,0);
end;

procedure TMyMDI.List (var Msg: TMessage);
var SavedListData:ListDataRec;
begin
  SavedListData:=ListData;
  if (IDOK=Application^.ExecDialog(new(PGroupsDlg,Init(@self)))) and
     ((SavedListData.lang<>ListData.lang) or
      (SavedListData.ComVsPriv<>ListData.ComVsPriv))
  then begin
    SetIndText;
    DoneIndex;
    InitIndex;
    SetIndText;
    PTL^.FillList;
    InvalidateRect(PTL^.HWindow,nil,true); UpdateWindow(PTL^.HWindow);
  end;
end;

procedure TMyMDI.Rubr (var Msg: TMessage);
begin
  SendMessage(GetActiveChild,WM_SYSCOMMAND,cmRubr,0);
  DoneIndex;
  InitIndex;
  SetRubText;
  PTL^.FillList;
  InvalidateRect(PTL^.HWindow,nil,true); UpdateWindow(PTL^.HWindow);
end;

procedure TMyMDI.SetIndText;
var str:string[12];
    pc:array[0..12] of char;
begin
  with ListData do begin
    if Lang=0 then str:='' else str:='';
    case ComVsPriv of
      1: str:=str+'+-';
      2: str:=str+'-+';
      3: str:=str+'++';
    end;
  end;
  StrPCopy(pc,str);
  StatusWin[1]^.SetText(pc);
end;

procedure TMyMDI.SetRubText;
var pc:array[0..5] of char;
begin
  if ListRubrics.Mask=[0..11] then StrPCopy(pc,'') else StrPCopy(pc,'');
  StatusWin[2]^.SetText(pc);
end;

function TMyMDI.FindTopicOnTheScreen (id:integer): PMyMDIChild;
  function found(P: PMyMDIChild): Boolean; far;
  begin
    found := id = P^.ChildId;
  end;
var Topic:PMyMDIChild;
begin
  Topic:=PMyMDIChild(FirstThat(@found));
  if Topic<>nil then begin
    SetWindowPos(Topic^.HWindow,{HWND_TOP=0}0,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE);
    if IsIconic(Topic^.HWindow) then OpenIcon(Topic^.HWindow);
  end;
  FindTopicOnTheScreen:=topic;
end;

function TMyMDI.CanCreateNewWindow : boolean;
var H:TSysHeapInfo;
    result:boolean;
begin
  H.dwSize:=SizeOf(TSysHeapInfo); SystemHeapInfo(@H);
  result:=H.wUserFreePercent>25;
  if not result then
    MessageBox(HWindow,'   '#13+'     ',
               '  !',MB_OK or MB_IconStop);
  CanCreateNewWindow:=result;
end;

procedure TMyMDI.ShowTopic (var Msg:TMessage); {topic was chosen by list}
var n:longint;
begin
  (*---
  n:=PTL^.CB^.GetSelIndex;
  if (n<0) then Exit;
  n:=PTL^.IndexN^[n];
  if (n>=0) and (FindTopicOnTheScreen(Index^.At(n)^.id)=nil) and
     CanCreateNewWindow
  then
    Application^.MakeWindow(new(PTopicWindow,Init(@Self,n,true,TheFont,Printer)));
  ---*)
  n:=1+PTL^.CB^.GetSelIndex;
  if (n<1) then Exit;
  if (n>=0) and (FindTopicOnTheScreen(cIndex^.getId(n))=nil) and
     CanCreateNewWindow
  then
    Application^.MakeWindow(new(PTopicWindow,Init(@Self,cIndex^.getId(n),true,TheFont,Printer)));
end;

procedure TMyMDI.ShowTopic1 (var Msg:TMessage); {next topic was chosen by HT link}
var n:integer;
begin
  (*---
  if Msg.LParam<>0 then begin
    found:=-1;
    for i:=0 to Index^.Count-1 do
      if Msg.LParam=Index^.At(i)^.id then begin
        found:=i; Break;
      end;
    if found>=0 then
      if (FindTopicOnTheScreen(Msg.LParam)=nil) and CanCreateNewWindow then
        Application^.MakeWindow(new(PTopicWindow,Init(@self,found,false,TheFont,Printer)))
      else
    else
      MessageBox(HWindow,
                 '      ',
                 nil,MB_OK or MB_ICONEXCLAMATION);
  end
  ---*)
  n:=Msg.LParam;
  if (n>=0) and (FindTopicOnTheScreen(n)=nil) and
     CanCreateNewWindow
  then
    Application^.MakeWindow(new(PTopicWindow,Init(@Self,n,true,TheFont,Printer)));
end;

procedure TMyMDI.CloseChildren;
  procedure DelMessage (AChild: PWindowsObject); far;
  begin
    SendMessage(AChild^.HWindow,cm_DoYouWishToBeClosed,0,0);
  end;
begin
  ForEach(@DelMessage);
end;

procedure TMyMDI.EscPressed (var Msg:TMessage);
var ActChild:HWND;
begin
  ActChild:=GetActiveChild;
  SendMessage(ActChild,cm_DoYouWishToBeClosed,0,0);
  if ActChild=GetActiveChild then CloseWindow;
end;

procedure TMyMDI.FocusList (var Msg: TMessage);
begin
  SetWindowPos(PTL^.HWindow,0,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE);
  if IsIconic(PTL^.HWindow) then OpenIcon(PTL^.HWindow);
end;

var FontW,FontH,FontIt,FontCharSet:integer;
    FontFace:string[80];

procedure TMyMDI.MakeDefaultFont(var AFont: HFont);
begin
  FillChar(MainLogFont, SizeOf(TLogFont), #0);
  with MainLogFont do begin
    lfHeight :=FontH;
    lfWeight :=FontW;
    lfItalic :=FontIt;
    lfCharSet:=FontCharSet;
    StrPCopy(lfFaceName,FontFace);
  end;
  TheFont:=CreateFontIndirect(MainLogFont);
end;

procedure TMyMDI.CMSetupPrinter (var Msg: TMessage);
begin
  Printer^.Setup(@Self);
end;

procedure TMyMDI.CMFonts(var Msg: TMessage);
  procedure FontMessage (AChild: PWindowsObject); far;
  begin
    SendMessage(AChild^.HWindow,cm_FontChanged,TheFont,0);
  end;
var ChooseRec: TChooseFont;
begin
  FillChar(ChooseRec, SizeOf(ChooseRec), #0);
  with ChooseRec do begin
    lStructSize:=SizeOf(TChooseFont);
    hwndOwner:=HWindow;
    lpLogFont:=@MainLogFont;
    Flags:=cf_AnsiOnly or cf_ttOnly or cf_ScreenFonts or
           cf_InitToLogFontStruct or cf_LimitSize;
    nSizeMin:=5; nSizeMax:=14;
  end;
  if not ChooseFont(ChooseRec) then Exit;

  if TheFont <> 0 then DeleteObject(TheFont);
  TheFont:=CreateFontIndirect(MainLogFont);
  ForEach(@FontMessage);
end;

procedure TMyMDI.MinimizeAll (var Msg:TMessage);
  procedure CloseWin (AChild: PWindowsObject); far;
  begin
    if AChild^.IsFlagSet(wb_MDIChild) then
      WinProcs.CloseWindow(AChild^.HWindow);
  end;
begin
  ForEach(@CloseWin);
end;

const IniFileName='elw.ini';
      IniMain='MainWindow';
      IniRubr='Rubrics';
      IniList='TermList';
      IniFont='FontUsed';
      IniTopic='Topics';

procedure TMyMDI.SaveSt (var Msg:TMessage);
var pc:array[0..80] of char;
    NTopics:integer;
  function int2pc (i:integer) : PChar;
  begin
    StrPCopy(pc,Long2Str(i));
    int2pc:=pc;
  end;
  procedure SaveWin (AChild: PWindowsObject); far;
  var p:PMyMdiChild;
      pt:PTopicWindow;
      pc1:array[0..80] of char;
      str:string[80];
      n:integer;
  begin
    if AChild^.IsFlagSet(wb_MDIChild) then begin
      p:=PMyMdiChild(AChild);
      if IsIconic(p^.HWindow) then str:='0' else
        if IsZoomed(p^.HWindow) then str:='2' else str:='1';
      str:=str+' '+long2str(p^.ChildId)+' '+
           long2str(p^.Attr.X)+' '+long2str(p^.Attr.Y)+' '+
           long2str(p^.Attr.W)+' '+long2str(p^.Attr.H);
      if p^.ChildId>=0 then begin
        inc(NTopics); n:=NTopics;
        pt:=PTopicWindow(p);
        str:=str+' '+long2str(pt^.HP1)+' '+long2str(pt^.HP2);
      end
      else n:=p^.ChildId;
      WritePrivateProfileString(IniTopic,int2pc(n),StrPCopy(pc1,str),LP(IniFileName));
    end;
  end;
var i:integer;
    WRect : TRECT;
    f:file;
begin
  GetWindowRect(HWindow, WRect);
  if not WritePrivateProfileString(IniMain,'X',int2pc(WRect.left),LP(IniFileName)) then
    MessageBox(HWindow,'      ELW.INI','',MB_OK or MB_IconEXCLAMATION)
  else begin
    WritePrivateProfileString(IniMain,'Y',int2pc(WRect.top),LP(IniFileName));
    WritePrivateProfileString(IniMain,'W',int2pc(WRect.right-WRect.left),LP(IniFileName));
    WritePrivateProfileString(IniMain,'H',int2pc(WRect.bottom-WRect.top),LP(IniFileName));
    if IsIconic(HWindow) then i:=0 else
      if IsZoomed(HWindow) then i:=2 else i:=1;
    WritePrivateProfileString(IniMain,'State',int2pc(i),LP(IniFileName));
    with MainLogFont do begin
      WritePrivateProfileString(IniFont,'Face',lfFaceName,LP(IniFileName));
      WritePrivateProfileString(IniFont,'H',int2pc(abs(lfHeight)),LP(IniFileName));
      WritePrivateProfileString(IniFont,'W',int2pc(lfWeight),LP(IniFileName));
      if lfItalic=0 then i:=0 else i:=1;
      WritePrivateProfileString(IniFont,'IsItalic',int2pc(i),LP(IniFileName));
      WritePrivateProfileString(IniFont,'CharSet',int2pc(lfCharSet),LP(IniFileName));
    end;
    for i:=1 to 12 do
      if (i-1) in ListRubrics.Mask then
        WritePrivateProfileString(iniRubr,int2pc(i),'1',LP(IniFileName))
      else
        WritePrivateProfileString(iniRubr,int2pc(i),'0',LP(IniFileName));
    WritePrivateProfileString(IniList,'Lang',int2pc(ListData.Lang),LP(IniFileName));
    WritePrivateProfileString(IniList,'CommPriv',int2pc(ListData.ComVsPriv),LP(IniFileName));
    WritePrivateProfileString(nil,nil,nil,LP(IniFileName));
    WritePrivateProfileString(IniTopic,nil,nil,LP(IniFileName));
    WritePrivateProfileString(IniTopic,'NTopic','0',LP(IniFileName));
    NTopics:=0;
    ForEach(@SaveWin);
    WritePrivateProfileString(IniTopic,'NTopic',int2pc(NTopics),LP(IniFileName));
  end;
end;

procedure TMyMDI.LoadSt (var Msg:TMessage);
begin
  {if TheFont<>0 then DeleteObject(TheFont);}
  CloseChildren;
  MainX:=-1;
  Loading;
  case MainState of
  0: WinProcs.ShowWindow(HWindow,SW_MINIMIZE);
  1: begin
      WinProcs.ShowWindow(HWindow,SW_ShowNormal);
      MoveWindow(HWindow,MainX,MainY,MainW,MainH,true);
     end;
  2: WinProcs.ShowWindow(HWindow,SW_ShowMaximized);
  else
    WinProcs.ShowWindow(HWindow,SW_ShowNormal);
    MoveWindow(HWindow,MainX,MainY,MainW,MainH,true);
  end;
  SetIndText; SetRubText;
  PTL^.FillList;
  {MakeDefaultFont(TheFont);}
  ShowSavedTopics;
end;

procedure TMyMDI.LoadDefSt (var Msg:TMessage);
begin
  {if TheFont<>0 then DeleteObject(TheFont);}
  CloseChildren;
  WinProcs.ShowWindow(HWindow,SW_ShowNormal);
  MoveWindow(HWindow,0,0,GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN),true);
  with ListRubrics do begin Mask:=[0..11]; AllOrPart:=1 end;
  {FontW:=400; FontH:=16; FontIt:=0; FontCharSet:=0; FontFace:='Journal';}
  with ListData do begin Lang:=0; ComVsPriv:=3 end;
  SetIndText; SetRubText;
  PTL^.FillList;
  {MakeDefaultFont(TheFont);}
end;

procedure TMyMDI.Loading;
var pc:array[0..80] of char;
  function int2pc (i:integer) : PChar;
  begin
    StrPCopy(pc,Long2Str(i));
    int2pc:=pc;
  end;
var i:integer;
begin
  GetPrivateProfileString(IniMain,'X','0',pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and (i>=0) then MainX:=i;
  GetPrivateProfileString(IniMain,'Y','0',pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and (i>=0) then MainY:=i;
  GetPrivateProfileString(IniMain,'W',int2pc(GetSystemMetrics(SM_CXSCREEN)),pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and (i>=0) then MainW:=i;
  GetPrivateProfileString(IniMain,'H',int2pc(GetSystemMetrics(SM_CYSCREEN)),pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and (i>=0) then MainH:=i;
  GetPrivateProfileString(IniMain,'State','1',pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and (i in [0..2]) then MainState:=i;

  ListRubrics.Mask:=[];
  for i:=1 to 12 do begin
    GetPrivateProfileString(iniRubr,int2pc(i),'1',pc,80,LP(IniFileName));
    if pc[0]='1' then ListRubrics.Mask:=ListRubrics.Mask+[i-1];
  end;
  if ListRubrics.Mask=[] then ListRubrics.Mask:=[0..11];
  if ListRubrics.Mask=[0..11] then ListRubrics.AllOrPart:=1 else ListRubrics.AllOrPart:=0;

  GetPrivateProfileString(IniFont,'Face',StrPCopy(pc,FontFace),pc,80,LP(IniFileName));
  FontFace:=StrPas(pc);
  GetPrivateProfileString(IniFont,'H',int2pc(FontH),pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and (i in [5..15]) then FontH:=i;
  GetPrivateProfileString(IniFont,'W',int2pc(FontW),pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and ((i=400) or (i=700)) then FontW:=i;
  GetPrivateProfileString(IniFont,'IsItalic',int2pc(FontIt),pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and (i in [0,1]) then FontIt:=i;
  GetPrivateProfileString(IniFont,'CharSet',int2pc(FontCharSet),pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and (i>=0) then FontCharSet:=i;

  GetPrivateProfileString(IniList,'Lang','0',pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and (i in [0..1]) then ListData.Lang:=i;
  GetPrivateProfileString(IniList,'CommPriv','3',pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),i) and (i in [1..3]) then ListData.ComVsPriv:=i;
end;

procedure TMyMDI.ShowSavedTopics;
var ar:array[1..8] of integer;
    pc:array[0..80] of char;
  function LoadStr (code,n:integer) : boolean;
    function int2pc (i:integer) : PChar;
    begin
      StrPCopy(pc,Long2Str(i));
      int2pc:=pc;
    end;
  var str:string[80];
      str1:string[10];
      i:integer;
  begin
    GetPrivateProfileString(IniTopic,int2pc(code),'',pc,80,LP(IniFileName));
    str:=StrPas(pc)+' ';
    i:=0;
    repeat
      i:=i+1;
      str1:=copy(str,1,pos(' ',str)-1);
      delete(str,1,pos(' ',str));
      if (str1='') or (not Str2Int(str1,ar[i])) then ar[i]:=-99;
    until (i=n) or (ar[i]=-99);
    LoadStr:=(i=n) and (ar[i]<>-99);
  end;
var i,j,n,found:integer;
    pt:PTopicWindow;
begin
  if LoadStr(-1,6) then begin
    MoveWindow(PTL^.HWindow,ar[3],ar[4],ar[5],ar[6],true);
    case ar[1] of
      0: WinProcs.CloseWindow(PTL^.HWindow);
      1: ShowWindow(PTL^.HWindow,SW_ShowNormal);
      2: ShowWindow(PTL^.HWindow,SW_ShowMaximized);
    end;
  end;
  if LoadStr(-2,6) then begin
    Application^.MakeWindow(new(PRefWindow,Init(@self,TheFont)));
    if RefWin<>0 then begin
      MoveWindow(RefWin,ar[3],ar[4],ar[5],ar[6],true);
      if 0=ar[1] then WinProcs.CloseWindow(RefWin);
    end;
  end;
  GetPrivateProfileString(IniTopic,'NTopic','0',pc,80,LP(IniFileName));
  if Str2Int(StrPas(pc),n) and (n>=0) then
    for j:=1 to n do
      if LoadStr(j,8) and (ar[2]>0) then begin
        (*---
        found:=-1;
        for i:=0 to Index^.Count-1 do
          if ar[2]=Index^.At(i)^.id then begin
            found:=i; Break;
          end;
        ---*)
        if {found>=0}true then
          if (FindTopicOnTheScreen(ar[2])=nil) and CanCreateNewWindow then begin
            pt:=new(PTopicWindow,Init(@self,{found}ar[2],false,TheFont,Printer));
            pt^.HP1:=ar[7]; pt^.HP2:=ar[8];
            Application^.MakeWindow(pt);
            if pt^.HWindow<>0 then begin
              MoveWindow(pt^.HWindow,ar[3],ar[4],ar[5],ar[6],true);
              if 0=ar[1] then WinProcs.CloseWindow(pt^.HWindow);
            end;
          end
          else
        else
          MessageBox(HWindow,
                     StrPCopy(pc,'    ID='+long2str(ar[2])),
                     nil,MB_OK or MB_ICONEXCLAMATION);
      end;
end;


procedure LoadAndCheckBase(aHWindow : HWnd);
var
 Result_ : Integer;
 Message : array[0..80] of Char;
begin
 Result_ := ReadHeader(StrPas(DP('el.dta')));
 if Result_ <> DTA_OK then
  begin
   case Result_ of
    DTA_NODTA:      StrPCopy(Message, EMSG_NODTA);
    DTA_BROKEN:     StrPCopy(Message, EMSG_BROKEN);
    DTA_UNKNOWN:    StrPCopy(Message, EMSG_UNKNOWN);
    DTA_UNREGISTER: StrPCopy(Message, EMSG_UNREGISTER);
   else
    StrPCopy(Message, EMSG_COMMON);
   end;
   MessageBox(aHWindow, Message, EMSG_CAPTION, MB_ICONHAND OR MB_OK);
   {if Result_ <> DTA_UNREGISTER then Halt;}
  end;
end;

{--------------------------------------}
var ElwApp: TElwApp;
    HWin:HWND;
begin
  if (hPrevInst<>0) then begin
    HWin:=FindWindow(ElwClassName,nil);
    if (HWin<>0) then begin
      SetActiveWindow(HWin);
      if (IsIconic(HWin)) then OpenIcon(HWin);
    end
  end
  else begin
    FontW:=400; FontH:=16; FontIt:=0; FontFace:='Arial Cyr';
    ElwApp.Init('');
    ElwApp.Run;
    ElwApp.Done;
  end;
end.
