{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O+,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 1024,0,0}

unit GrPDlg; {Graphics Parms Dlg}

interface

uses WinTypes, WinProcs, OWindows, ODialogs, Strings,
     TpString,
     TraxRun, TraxPlot;

type
  TGrPDlg=object(TDialog)
    pds:PDynSystem;
    lb:PListBox;
    h,v:integer;
    constructor Init (AParent:PWindowsObject; ThePDS:PDynSystem);
    procedure SetupWindow; virtual;
    function CanClose : boolean; virtual;
    procedure HSel (var Msg:TMessage); virtual ID_FIRST+104;
    procedure VSel (var Msg:TMessage); virtual ID_FIRST+105;
  end;
  PGrPDlg=^TGrPDlg;

implementation

const TName='t (Step)';

constructor TGrPDlg.Init (AParent:PWindowsObject; ThePDS:PDynSystem);
begin
  inherited Init(AParent,'GraphParmsDlg');
  pds:=ThePDS; h:=-1; v:=-1;
  lb:=new(PListBox,InitResource(@self,101));
end;

procedure TGrPDlg.SetupWindow;
var i:integer;
    p:array[0..100] of char;
begin
  inherited SetupWindow;
  lb^.AddString(TName);
  for i:=1 to pds^.NVars do
    lb^.AddString(StrPCopy(p,pds^.VarNames^[i]^));
  lb^.SetSelIndex(0);
end;

function TGrPDlg.CanClose : boolean;
var vals:array[106..109] of real;
    str:string;
    i:integer;
    p:array[0..100] of char;
    ppw:PPlotWin;
begin
  CanClose:=false;
  if (h=-1) then begin
    MessageBox(HWindow,'Horisontal axis variable is not specified',nil,mb_OK or MB_IconExclamation);
    EXIT;
  end;
  if (v=-1) then begin
    MessageBox(HWindow,'Vertical axis variable is not specified',nil,mb_OK or MB_IconExclamation);
    EXIT;
  end;
  if (h=v) then begin
    MessageBox(HWindow,'The same variable is chosen for both axes',nil,mb_OK or MB_IconExclamation);
    EXIT;
  end;
  for i:=106 to 109 do begin
    GetWindowText(GetDlgItem(HWindow,i),p,100);
    str:=Trim(StrPas(p));
    if str='' then begin
      MessageBox(HWindow,'Value is not specified',nil,mb_OK or MB_IconExclamation);
      SetFocus(GetDlgItem(HWindow,i));
      EXIT;
    end;
    if not Str2Real(str,vals[i]) then begin
      MessageBox(HWindow,'Not a number',nil,mb_OK or MB_IconExclamation);
      SetFocus(GetDlgItem(HWindow,i));
      EXIT;
    end;
  end;
  if (vals[106]>=vals[108]) or (vals[107]>=vals[109]) then begin
    MessageBox(HWindow,'HIGN bound is less then LOW bound',nil,mb_OK or MB_IconExclamation);
    EXIT;
  end;
  CanClose:=true;
  ppw:=new(PPlotWin,Init(Parent,pds,h,v,vals[106],vals[108],vals[107],vals[109]));
  Application^.MakeWindow(ppw);
end;

procedure TGrPDlg.HSel (var Msg:TMessage);
var p:array[0..100] of char;
    n:integer;
begin
  if lb^.GetSelIndex>=0 then begin
    h:=lb^.GetSelIndex;
    SetWindowText(GetDlgItem(HWindow,106),'');
    SetWindowText(GetDlgItem(HWindow,108),'');
    if h=0 then begin
      SetWindowText(GetDlgItem(HWindow,102),TName);
      SetWindowText(GetDlgItem(HWindow,106),StrPCopy(p,Long2Str(pds^.t0)));
      if pds^.IsTDefined then
        SetWindowText(GetDlgItem(HWindow,108),StrPCopy(p,Long2Str(pds^.tfin)));
    end
    else begin
      SetWindowText(GetDlgItem(HWindow,102),StrPCopy(p,pds^.VarNames^[h]^));
      n:=pds^.FindCondition(h);
      if n>0 then
        with pds^.Cond^[n]^ do begin
          if IsLowDefined then
            SetWindowText(GetDlgItem(HWindow,106),StrPCopy(p,Real2Str(LowBound,10,6)));
          if IsHighDefined then
            SetWindowText(GetDlgItem(HWindow,108),StrPCopy(p,Real2Str(HighBound,10,6)));
        end;
    end;
  end;
end;

procedure TGrPDlg.VSel (var Msg:TMessage);
var p:array[0..100] of char;
    n:integer;
begin
  if lb^.GetSelIndex>=0 then begin
    v:=lb^.GetSelIndex;
    SetWindowText(GetDlgItem(HWindow,107),'');
    SetWindowText(GetDlgItem(HWindow,109),'');
    if v=0 then begin
      SetWindowText(GetDlgItem(HWindow,103),TName);
      SetWindowText(GetDlgItem(HWindow,107),StrPCopy(p,Long2Str(pds^.t0)));
      if pds^.IsTDefined then
        SetWindowText(GetDlgItem(HWindow,109),StrPCopy(p,Long2Str(pds^.tfin)));
    end
    else begin
      SetWindowText(GetDlgItem(HWindow,103),StrPCopy(p,pds^.VarNames^[v]^));
      n:=pds^.FindCondition(v);
      if n>0 then
        with pds^.Cond^[n]^ do begin
          if IsLowDefined then
            SetWindowText(GetDlgItem(HWindow,107),StrPCopy(p,Real2Str(LowBound,10,6)));
          if IsHighDefined then
            SetWindowText(GetDlgItem(HWindow,109),StrPCopy(p,Real2Str(HighBound,10,6)));
        end;
    end;
  end;
end;

end.
