unit MsgWin;

interface

uses WinTypes, WinProcs, OWindows, Strings;

type
  PMsgWin=^TMsgWin;
  TMsgWin=object(TWindow)
    X,Y:integer;
    PTxt:array[0..255] of char;
    constructor Init(AParent:PWindowsObject; ATxt:string; ax,ay:integer);
    function GetClassName : PChar; virtual;
    procedure GetWindowClass (var AWndClass: TWndClass); virtual;
    procedure Paint (PaintDC:HDC; var PaintInfo:TPaintStruct); virtual;
    procedure CalcSize;
  end;

function StartMessage (AParent:PWindowsObject; Text:string; X,Y:integer) : PMsgWin;
procedure FinishMessage (var MW:PWindowsObject);


implementation

function StartMessage (AParent:PWindowsObject; Text:string; X,Y:integer) : PMsgWin;
var MW:PMsgWin;
begin
  MW:=new(PMsgWin,Init(AParent,Text,x,y));
  if (MW<>nil) then begin
    Application^.MakeWindow(MW);
    UpdateWindow(MW^.HWindow);
  end;
  StartMessage:=MW;
end;

procedure FinishMessage (var MW:PWindowsObject);
begin
  if (MW=nil) then Exit;
  MW^.CloseWindow; MW:=nil;
end;

{---------------------------------------------}
constructor TMsgWin.Init (AParent:PWindowsObject; ATxt:string; ax,ay:integer);
begin
  inherited Init (AParent,'');
  StrPCopy(PTxt,ATxt);
  x:=ax; y:=ay;
  Attr.Style:=WS_CHILD or WS_BORDER or WS_VISIBLE;
  SetFlags(WB_MDICHILD,FALSE);
  CalcSize;
  DisableAutoCreate;
end;

function TMsgWin.GetClassname : PChar;
begin
  GetClassName:='PMessageWindow';
end;

procedure TMsgWin.GetWindowClass (var AWndClass:TWndClass);
begin
  inherited GetWindowClass (AWndClass);
  with AWndClass do
    hbrBackground:=CreateSolidBrush(RGB(255,255,127));
end;

procedure TMsgWin.Paint (PaintDC:HDC; var PaintInfo:TPaintStruct);
var rc:TRect;
begin
  GetClientRect(HWindow,rc);
  SetBkMode(PaintDC,Transparent);
  DrawText(PaintDC,PTxt,strlen(PTxt),rc,DT_CENTER or DT_WORDBREAK);
end;

procedure TMsgWin.CalcSize;
var DC:HDC;
    rc:TRect;
    minw:integer;
    W,H:word;
begin
  DC:=GetDC(Parent^.HWindow);
  FillChar(rc,sizeof(rc),0);
  DrawText(DC,PTxt,strlen(PTxt),rc,DT_WORDBREAK or DT_CALCRECT);
  inc(rc.right,10); {inc(rc.bottom,5);}
  AdjustWindowRect(rc,Attr.Style,false);
  W:=rc.right+2; H:=rc.bottom+2;
  GetWindowRect(GetDesktopWindow,rc);
  if (Y<rc.top) then Y:=rc.top;
  if (X<rc.left) then X:=rc.left;
  if (X+W>rc.right) then X:=rc.right-W;
  if (Y+H>rc.bottom) then Y:=rc.bottom-H;
  Attr.X:=X; Attr.Y:=Y; Attr.W:=W; Attr.H:=H;
  ReleaseDC(Parent^.HWindow,DC);
end;

end.