{$A+,B-,D+,F-,G+,I+,K+,L+,N-,P-,Q-,R-,S+,T-,V+,W+,X+,Y+}
{$M 16384,8192}
program Trax2;

uses WinProcs, WinTypes, Objects, OWindows, ODialogs,
     CommDlg, ToolHelp,
     Strings, TpString,
     ExMDI, CalcDlg,
     TraxCode, Trax_Abo, TraxPars, TraxRun, TraxVals, GrPDlg, TraxPlot, TraxCol;

{$R Trax.RES}

const WM_CalcDlgClosed=WM_USER+98;
type
  PRetVal=^integer;
  TTraxCalc=object (TCalcDlg)
    pds:PDynSystem;
    prv:PRetVal;
    constructor Init (AParent:PWindowsObject; ThePDS:PDynSystem; pRetValue:pRetVal);
      {ret.value= 0-not started, 1-still works, 2-exit conditions,
       3-all undefined, -1-user's break, -2-program break}
    function Calc : integer; virtual;
    procedure Cancel (var Msg:TMessage); virtual ID_FIRST+IDCANCEL;
    function CanClose : boolean; virtual;
  end;
  PTraxCalc=^TTraxCalc;

  TTraxApp = object(TApplication)
    procedure InitMainWindow; virtual;
    {function IdleAction:boolean; virtual;}
  end;

  PMyMDI=^TMyMDI;
  TMyMDI=object(TExMDIWindow)
    pds:PDynSystem;
    pget:^TGetInitValues;
    calcstate:integer;
    ptc:PTraxCalc;
    ovw:POutValsWin;
    constructor Init (ATitle:Pchar; AMenu:THandle);
    destructor Done; virtual;
    function GetProgramCopyright:string; virtual;
    function GetClassName:PChar; virtual;
    procedure GetWindowClass(var WndClass:TWndClass); virtual;
    procedure CreateSpeedBar; virtual;
    procedure GetStatusText (ID:Word; Buffer:PChar; BufferMax:Integer); virtual;
    procedure About (var Msg: TMessage); virtual cm_First+cmAbout;
    procedure GetFormulas (var Msg: TMessage); virtual cm_First+1012;
    procedure GetInitState (var Msg: TMessage); virtual cm_First+1013;
    procedure GetBounds (var Msg: TMessage); virtual cm_First+1015;
    procedure Run (var Msg: TMessage); virtual cm_First+1037;
    procedure Continue (var Msg: TMessage); virtual cm_First+1035;
    procedure DoCalc;
    procedure NewGraphWin (var Msg: TMessage); virtual cm_First+1041;
    procedure SetupColors (var Msg: TMessage); virtual cm_First+1042;
    procedure SendMessageToChildren(Message:word; wparam:word; lparam:longint);

    function GetFileName (ftype:char; var InputFileName:string) : boolean;
      {ftype= 'f' (formulas), 'v' (values), 'b' (bounds)}
    procedure ovwClosed(var Msg:TMessage); virtual WM_first+WM_ShowVarValuesClosed;
    procedure CalcClosed(var Msg:TMessage); virtual WM_first+WM_CalcDlgClosed;
  end;

procedure TTraxApp.InitMainWindow;
var pc:array[0..79] of char;
begin
  VerStr:=long2str(ver)+'.'+LeftPadCh(long2str(subver),'0',2);
  StrPCopy(pc,'New Trax');
  MainWindow:=New(PMyMDI,Init(pc,LoadMenu(HInstance,'MainMenu')));
  {HAccTable:=LoadAccelerators(HInstance,'AccTable');}
  PMDIWindow(MainWindow)^.ChildMenuPos:=2;
end;

constructor TMyMDI.Init (ATitle:Pchar; AMenu:THandle);
begin
  inherited Init(ATitle,AMenu);
  pds:=nil; pget:=nil; ptc:=nil; ovw:=nil;
  calcstate:=0;
end;

destructor TMyMDI.Done;
begin
  if pget<>nil then begin
    dispose(pget,Done);
    pget:=nil;
  end;
  if pds<>nil then dispose(pds,Done);
  inherited Done;
end;

function TMyMDI.GetProgramCopyright:string;
begin
  GetProgramCopyright:='(c) IMPB RAS 1997 Trax MS Windows version '+VerStr;
end;

const ElwClassName='TraxMainWindow';
function TMyMDI.GetClassName:PChar;
begin
  GetClassname:=ElwClassName;
end;

procedure TMyMDI.GetWindowClass(var WndClass:TWndClass);
begin
  inherited GetWindowClass(WndClass);
  WndClass.hIcon:=LoadIcon(HInstance,'AMainWinIco');
end;

procedure TMyMDI.CreateSpeedBar;
begin
  if SpeedBar<>nil then SpeedBar^.Free;
  SpeedBar:=New(PSpeedBar,Init(@Self,StatusLine));
  with SpeedBar^ do begin
    AddATool(cm_HelpContents,Pchar('BtnHelp'),'Help');
    AddSeparator;
    AddATool(1012,PChar('Btn1'),'Load formulas');
    AddATool(1013,PChar('Btn2'),'Load initial values');
    AddATool(1015,PChar('Btn3'),'Load bounds');
    AddSeparator;
    AddATool(1041,PChar('BtnGraph'),'Create window with graphics');
    AddATool(1042,PChar('BtnColors'),'Setup colors for graphics');
    AddATool(1037,PChar('BtnRun'),'Run calculations');
    AddATool(1035,PChar('BtnRunAgain'),'Continue calculations');
    AddSeparator;
    AddATool(992,PChar('BtnPrev'),'Previous window');
    AddATool(991,PChar('BtnNext'),'Next window');
    AddATool(cmMinAll,PChar('BtnMini'),'Minimize all windows');
    AddATool(cm_CloseChildren,PChar('BtnClose'),'Close all windows');
    AddSeparator;
    AddATool(cm_Exit,Pchar('BtnQuit'),'Quit');
  end;
end;

procedure TMyMDI.GetStatusText (ID:Word; Buffer:PChar; BufferMax:Integer);
var str:string;
begin
  inherited GetStatusText(ID,Buffer,BufferMax);
  if Buffer[0]=#0 then begin
    case ID of
      cm_HelpContents: str:='Trax system help context';
      cm_HelpHelp:     str:='How to use Windows help';
      cmAbout:   str:='About the system';
      cmLoadRHS: str:='Load RHS vector from the file';
      cmLoadX0: str:='Load X0 vector from the file';
      cmLoadConst: str:='Load named constants vector from the file';
      cmRunStart: str:='Run from X0';
      cmRunAgain: str:='Run from the point of the interrupt';
      cmNewGrWin: str:='Create new visualization window';
      cmMinAll: str:='Minimize all windows';
      998,1000..1004: str:=' ';
    else
      str:='New text for code = '+long2str(ID);
    end;
    StrPCopy(Buffer,copy(str,1,BufferMax-1));
  end;
end;

procedure TMyMDI.About (var Msg: TMessage);
begin
  Application^.ExecDialog(new(PAboutDlg,Init(@Self,VerStr)));
end;

function TMyMdi.GetFileName (ftype:char; var InputFileName:string) : boolean;
  {ftype= 'f' (formulas), 'v' (values), 'b' (bounds)}
const DefExt = 'txt';
var OpenFN:TOpenFileName;
    Filter:array [0..256] of Char;
    FilterStr:string;
    FullFileName,FileName,Title:array[0..127] of char;
begin
  StrPCopy(FullFileName, InputFileName);
  FillChar(Filter, SizeOf(Filter), #0);  { Set up for double null at end }
  FillChar(Title, SizeOf(Title), #0);
  FilterStr:='';
  case ftype of
    'f': FilterStr:='Formulas *.frm'+chr(0)+'*.frm'+chr(0);
    'v': FilterStr:='Initial values *.val'+chr(0)+'*.val'+chr(0);
    'b': FilterStr:='Bounds for variables *.bou'+chr(0)+'*.bou'+chr(0);
  end;
  FilterStr:=FilterStr+'Text files *.txt'+chr(0)+'*.txt'+chr(0)+
             'All files *.*'+chr(0)+'*.*'+chr(0)+chr(0);
  StrPCopy(Filter, FilterStr);
  FillChar(OpenFN, SizeOf(TOpenFileName), #0);
  StrPCopy(FileName,InputFileName);
  with OpenFN do begin
    hInstance     := HInstance;
    hwndOwner     := HWindow;
    lpstrDefExt   := DefExt;
    lpstrFile     := FullFileName;
    lpstrFilter   := Filter;
    lpstrFileTitle:= FileName;
    flags         := ofn_FileMustExist or ofn_HideReadOnly or ofn_NoChangeDIR;
    lStructSize   := sizeof(TOpenFileName);
    nFilterIndex  := 1; {Index into Filter String in lpstrFilter}
    nMaxFile      := SizeOf(FullFileName);
    case ftype of
      'f': StrPCopy(Title,'Specify the file with formulas');
      'v': StrPCopy(Title,'Specify the file with initial values');
      'b': StrPCopy(Title,'Specify the file with variables'' bounds');
    end;
    if Title[0]<>chr(0) then lpstrTitle:=Title;
  end;
  if GetOpenFileName(OpenFN) then begin
    InputFileName:=StrPas(FullFileName);
    GetFileName:=true;
  end
  else
    GetFileName:=false;
end;

procedure TMyMdi.SendMessageToChildren(Message:word; wparam:word; lparam:longint);
  procedure SendToChild (AChild:PWindowsObject); far;
  begin
    SendMessage(AChild^.HWindow,Message,wparam,lparam);
  end;
begin
  ForEach(@SendToChild);
end;

procedure TMyMdi.GetFormulas (var Msg: TMessage);
var str:string;
    fin,fout:text;
begin
  if ptc<>nil then begin
    calcstate:=-2; ptc^.CloseWindow; ptc:=nil; calcstate:=0;
  end;
  if pget<>nil then begin dispose(pget,Done); pget:=nil end;
  if pds<>nil then begin dispose(pds,Done); pds:=nil; end;
  str:='';
  CheckMenuItem(GetMenu(HWindow),1012,mf_ByCommand or mf_UnChecked);
  CheckMenuItem(GetMenu(HWindow),1013,mf_ByCommand or mf_UnChecked);
  CheckMenuItem(GetMenu(HWindow),1015,mf_ByCommand or mf_UnChecked);
  if GetFileName('f',str) then begin
    assign(fin,str); reset(fin);
    assign(fout,'parse.log'); rewrite(fout);
    pds:=Parse(fin,fout); { Parse itself closes fin & fout }
    if pds=nil then begin
      MessageBox(HWindow,'Errors in file with formulas, see PARSE.LOG for details',nil,mb_ok or mb_IconExclamation);
      CheckMenuItem(GetMenu(HWindow),1012,mf_ByCommand or mf_unChecked);
    end
    else begin
      CheckMenuItem(GetMenu(HWindow),1012,mf_ByCommand or mf_Checked);
      if ovw=nil then begin
        ovw:=new(POutValsWin,Init(@self,pds));
        Application^.MakeWindow(ovw);
      end
      else begin
        ovw^.pds:=pds;
        InvalidateRect(ovw^.HWindow,nil,TRUE);
      end;
    end;
  end;
  SendMessageToChildren(WM_Shut,0,0);
end;

procedure TMyMdi.GetInitState (var Msg: TMessage);
var str:string;
    fin:text;
begin
  if ptc<>nil then begin
    calcstate:=-2; ptc^.CloseWindow; ptc:=nil; calcstate:=0;
  end;
  if pds=nil then begin
    MessageBox(HWindow,'No formulas loaded',nil,mb_ok or mb_IconExclamation);
    Exit;
  end;
  CheckMenuItem(GetMenu(HWindow),1013,mf_ByCommand or mf_UnChecked);
  str:='';
  SendMessageToChildren(WM_Reset,0,0);
  if GetFileName('v',str) then begin
    assign(fin,str); reset(fin);
    pds^.AllocMemForWork;
    if pget=nil then begin
      new(pget,Init);
      pget^.SetDynSystem(pds);
    end;
    if not pget^.ReadValuesFromFile(fin) then
      MessageBox(HWindow,'Error while loading initial values',nil,mb_ok or mb_IconExclamation);
    close(fin);
    if not pget^.AreAllDefined then
      MessageBox(HWindow,'Not all initial values are defined',nil,mb_ok or mb_IconExclamation)
    else begin
      pds^.Reset;
      CheckMenuItem(GetMenu(HWindow),1013,mf_ByCommand or mf_Checked);
      if ovw=nil then begin
        ovw:=new(POutValsWin,Init(@self,pds));
        Application^.MakeWindow(ovw);
      end
      else begin
        ovw^.pds:=pds;
        InvalidateRect(ovw^.HWindow,nil,TRUE);
      end;
    end;
  end;
end;

procedure TMyMDI.GetBounds (var Msg: TMessage);
var str:string;
    fin:text;
begin
  if ptc<>nil then begin
    calcstate:=-2; ptc^.CloseWindow; ptc:=nil; calcstate:=0;
  end;
  if pds=nil then begin
    MessageBox(HWindow,'No formulas loaded',nil,mb_ok or mb_IconExclamation);
    Exit;
  end;
  if pget=nil then begin
    MessageBox(HWindow,'No initial state loaded',nil,mb_ok or mb_IconExclamation);
    Exit;
  end;
  CheckMenuItem(GetMenu(HWindow),1015,mf_ByCommand or mf_UnChecked);
  str:='';
  if GetFileName('b',str) then begin
    assign(fin,str); reset(fin);
    pget^.ReadConditionsFromFile(fin);
    close(fin);
    CheckMenuItem(GetMenu(HWindow),1015,mf_ByCommand or mf_Checked);
    if ovw=nil then begin
      ovw:=new(POutValsWin,Init(@self,pds));
      Application^.MakeWindow(ovw);
    end
    else begin
      ovw^.pds:=pds;
      InvalidateRect(ovw^.HWindow,nil,TRUE);
    end;
  end;
end;

procedure TMyMdi.ovwClosed(var Msg:TMessage);
begin
  ovw:=nil;
end;

procedure TMyMdi.CalcClosed(var Msg:TMessage);
begin
  ptc:=nil;
end;

procedure TMyMdi.Run (var Msg: TMessage);
begin
  if ptc<>nil then begin
    calcstate:=-2; ptc^.CloseWindow; ptc:=nil; calcstate:=0;
  end;
  if (pds<>nil) and (pget<>nil) then begin
    pds^.reset;
    SendMessageToChildren(WM_Reset,0,0);
  end;
  DoCalc;
end;

procedure TMyMdi.Continue (var Msg: TMessage);
begin
  if ptc=nil then DoCalc;
end;

procedure TMyMdi.DoCalc;
var ps:array[0..127] of char;
begin
  if (pds=nil) then begin
    MessageBox(HWindow,'No formulas are loaded',nil,mb_ok or mb_IconExclamation);
    EXIT;
  end;
  if (pget=nil) or (not pget^.AreAllDefined) then begin
    MessageBox(HWindow,'Initial state is undefined',nil,mb_ok or mb_IconExclamation);
    EXIT;
  end;
  if pds^.AreAllUndefined then begin
    MessageBox(HWindow,'All variables are undefined',nil,mb_ok or mb_IconExclamation);
    EXIT;
  end;
  if pds^.MustFinish then begin
    StrPCopy(ps,'One of the exit conditions is reached: '+
               pds^.ConditionText(pds^.FindBrokenCondition)+' no more keeps');
    MessageBox(HWindow,ps,'Calculations are finished',mb_ok or mb_IconStop);
    EXIT;
  end;
  if ovw=nil then begin
    ovw:=new(POutValsWin,Init(@self,pds));
    Application^.MakeWindow(ovw);
  end;
  ptc:=new(PTraxCalc,Init(@self,pds,@calcstate));
  Application^.MakeWindow(ptc);
end;

procedure TMyMDI.NewGraphWin (var Msg: TMessage);
begin
  if ptc<>nil then Exit;
  if (pds<>nil) and
     (IDOK=Application^.ExecDialog(new(PGrPDlg,Init(@self,pds))))
  then;
end;

{---------TTraxCalc---------}
constructor TTraxCalc.Init (AParent:PWindowsObject; ThePDS:PDynSystem; pRetValue:pRetVal);
begin
  inherited Init(AParent);
  pds:=ThePDS; prv:=pRetValue;
  FixedMessage:='Calculations...';
end;

procedure TTraxCalc.Cancel (var Msg:TMessage);
begin
  prv^:=-1;
  inherited Cancel(Msg);
  CloseWindow;
end;

function TTraxCalc.Calc : integer;
  procedure DrawPlot (AChild:PWindowsObject); far;
  begin
    SendMessage(AChild^.HWindow,wm_NextPoint,0,0);
  end;
var i:integer;
begin
  for i:=1 to 1 do begin
    pds^.Next10Steps;
    {if i mod 10 = 0 then }DrawMessage('step '+long2str(pds^.TCurr));
    Parent^.ForEach(@DrawPlot);
    if pds^.AreAllUndefined then begin prv^:=3; Calc:=-1; EXIT end
    else
      if pds^.MustFinish then begin prv^:=2; Calc:=-1; EXIT end
      else
      if pds^.BecameUndefined then begin
        if (NTimer<>0) then KillTimer(HWindow,NTimer);
        if IDNO=MessageBox(HWindow,'One of the variables has become undefined. Continue the work?',
                   'ATTENTION',MB_YESNO or MB_ICONQUESTION)
        then begin
          prv^:=-1; Calc:=-1; NTimer:=0; EXIT
        end
        else begin
          Calc:=0; SetTimer(HWindow,NTimer,5,nil);
        end;
      end
      else Calc:=0;
  end;
end;

function TTraxCalc.CanClose : boolean;
var ps:array[0..127] of char;
begin
  SendMessage(Parent^.HWindow,WM_CalcDlgClosed,0,0);
  case prv^ of
    -2: MessageBox(HWindow,'Break of calculations','',mb_ok);
    -1: MessageBox(HWindow,'Pause in calculations','',mb_ok);
    2: begin
      StrPCopy(ps,'One of the exit conditions is reached: '+
                 pds^.ConditionText(pds^.FindBrokenCondition)+' no more keeps');
      MessageBox(HWindow,ps,'Calculations are finished',mb_ok);
    end;
    3: MessageBox(HWindow,'All variables have become undefined',
         'Calculations are impossible',MB_OK or MB_ICONSTOP);
  end;
  inherited CanClose;
end;

procedure TMyMDI.SetupColors (var Msg: TMessage);
begin
  if pds<>nil then
    Application^.ExecDialog(new(PColorsDlg,Init(@Self,pds)));
end;

{---------Main--------------}
var TraxApp:TTraxApp;
    i:integer;
begin
  TraxApp.Init('');
  for i:=1 to 7 do
    PlotPens[i]:=CreatePen(PS_SOLID,1,RGB(PlotColors[i,1],PlotColors[i,2],PlotColors[i,3]));
  TraxApp.Run;
  for i:=1 to 7 do
    DeleteObject(PlotPens[i]);
  TraxApp.Done;
end.