{$A+,B-,D+,E+,F+,G-,I+,L+,N+,O+,P-,Q+,R+,S+,T-,V-,X+,Y+}
{$M 1024,0,0}

unit TraxVals;

interface

uses WinTypes, WinProcs, OWindows, Strings,
     TpString,
     TraxRun;

const WM_NextPoint=WM_USER+1; WM_ShowVarValuesClosed=WM_USER+99;
type
  TOutValsWin=object(TWindow)
    pds:PDynSystem;
    dy,hvals,hcond:integer;

    constructor Init (AParent:PWindowsObject; ThePDS:PDynSystem);
    procedure Paint (PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    procedure WMSize(var Msg: TMessage); virtual wm_First + wm_Size;
    procedure NextPoint (var Msg:TMessage); virtual wm_first+WM_NextPoint;
    function GetClassName:PChar; virtual;
    procedure GetWindowClass(var WndClass:TWndClass); virtual;
    function CanClose:boolean;virtual;
  end;
  POutValsWin=^TOutValsWin;

implementation

constructor TOutValsWin.Init (AParent:PWindowsObject; ThePDS:PDynSystem);
var
  l:longint;
  DC:HDC;
  pc:array[0..10] of char;
  rect:TRect;
begin
  inherited Init (AParent,'Current variable values');
  pds:=ThePDS;
  StrPCopy(pc,'0123456789');
  DC:=GetDC(AParent^.HWindow);
  l:=GetTextExtent(DC,pc,10);
  ReleaseDC(AParent^.HWindow,DC);
  dy:=HiWord(l);
  Attr.W:=LoWord(l)*3+2*GetSystemMetrics(SM_CXFRAME);
  hvals:=dy*(pds^.NVars+1);
  hcond:=dy*(2+pds^.ncond);
  Attr.H:=hvals+hcond+2*GetSystemMetrics(SM_CYFRAME)+GetSystemMetrics(SM_CYCAPTION);
  if pds^.cond=nil then inc(Attr.H,3*dy);
  GetClientRect(AParent^.HWindow,rect);
  if Attr.H>rect.bottom then Attr.H:=rect.bottom;
  Attr.Style:=Attr.Style or WS_VScroll;
  new(Scroller,Init(@self,1,1,0,0));
end;

procedure TOutValsWin.WMSize(var Msg: TMessage);
var
  rect:TRect;
begin
  inherited WMSize(Msg);
  if not IsIconic(HWindow) then begin
    GetClientRect(HWindow,rect);
    if Scroller^.YRange+rect.bottom<>hvals+hcond then
      Scroller^.SetRange(0,hvals+hcond-rect.bottom);
  end;
end;

procedure TOutValsWin.NextPoint(var Msg: TMessage);
var
  rect:TRect;
begin
  if not IsIconic(HWindow) then begin
    GetClientRect(HWindow,rect);
    rect.bottom:=hvals;
    InvalidateRect(HWindow,@rect,true); UpdateWindow(HWindow);
  end;
end;

procedure TOutValsWin.Paint (PaintDC: HDC; var PaintInfo: TPaintStruct);
var i,hv,hc,y:integer;
    str:string;
    pstr:array[0..100] of char;
    rect:TRect;
begin
  hv:=dy*(pds^.NVars+1);
  hc:=dy*(2+pds^.ncond);
  if (hv<>hvals) or (hc<>hcond) then begin
    hvals:=hv; hcond:=hc;
    GetClientRect(HWindow,rect);
    Scroller^.SetRange(0,hvals+hcond-rect.bottom);
    InvalidateRect(HWindow,nil,true);
    exit;
  end;
  SetBkMode(PaintDC,TRANSPARENT);
  str:='t='+long2str(pds^.tcurr);
  TextOut(PaintDC,5,0,StrPCopy(pstr,str),length(str));
  y:=dy;
  for i:=1 to pds^.NVars do begin
    if (pds^.IsCurrUndefined=nil) or
       (pds^.VCurr=nil) or
       (pds^.IsCurrUndefined^[i])
    then
      str:=pds^.VarNames^[i]^+'=undefined'
    else
      str:=pds^.VarNames^[i]^+'='+real2str(pds^.VCurr^[i],10,6);
    TextOut(PaintDC,5,y,StrPCopy(pstr,str),length(str));
    inc(y,dy);
  end;
  str:='Restrictions on variables:';
  TextOut(PaintDC,5,y,StrPCopy(pstr,str),length(str));
  inc(y,dy);
  for i:=0 to pds^.ncond do begin
    str:=pds^.ConditionText(i);
    if str<>'' then begin
      TextOut(PaintDC,5,y,StrPCopy(pstr,str),length(str));
      inc(y,dy);
    end;
  end;
end;

function TOutValsWin.GetClassName:PChar;
begin
  GetClassname:='VarValsWindow';
end;

procedure TOutValsWin.GetWindowClass(var WndClass:TWndClass);
begin
  inherited GetWindowClass(WndClass);
  WndClass.hIcon:=LoadIcon(HInstance,'VarValsWin');
end;

function TOutValsWin.CanClose:boolean;
begin
  SendMessage(Parent^.HWindow,WM_ShowVarValuesClosed,0,0);
  CanClose:=true;
end;

end.